#include "list.h"

#define HASH_SZ 32 /* HASH_SZ * HASH_SZ rectacles */

typedef	unsigned char u8;
typedef	unsigned short u16;
typedef	unsigned long u32;

/* flags */
#define KARTTAPAIKKA8000 1 /* 1:8000 peruskartta */
#define KARTTAPAIKKA40000 2 /* 1:40000 aineisto (topografikartta) */
#define NOT_COLORIZE_BROWN 4 /* vrj ruskeaksi */

struct image {
  long xoff, yoff; /* from origo */
  long height, width;
  long res;
  u8 **data;
};

/* Fletcher's checksum of 8x8 rect */
struct hash {
  struct image *img_info;
  u32 hash;
  long x, y; /* local cord of img_info */
  struct list_head list;
};

/* file.c */
struct image * LoadPNG(const char *filename);
void DeletePNGrows (struct image *img);
int SavePNG(struct image *img, const char *filename);

/* stitch.c */
int MATCH(struct image *src, struct image *target, struct list_head *hash_list);
void MERGE(struct image *target, struct image *src);
void add_hashes(struct image *img, struct list_head *hash_list);

/* filter.c */
void init_k40000(void);
void clean_karttapaikka8000(struct image *img);
void clean_karttapaikka40000(struct image *img);
void colorize_brown(struct image *img);


